<template class="product-detail">
    <div class="container">
        <h4 class="fw-bold py-3 mb-4"><a href="/"><span class="text-muted fw-light">Trang chủ/</span></a> {{ product.category.name }}</h4>
        <div class="product-detail border-bottom d-flex justify-content-between">
            <div class="product-name">
                <h3>{{ product.name }}</h3>
            </div>
            <div class="review ">
                <div class="pt-1 d-flex align-items-center">
                    <span v-for="(star, index) in roundedNum(product.point)" :key="index" class="fa-stack m-1" style="width:1em;">
                        <i v-if="star > product.point" class="fas fa-star-half fa-stack-1x"></i>
                        <i v-else class="fas fa-star fa-stack-1x"></i>
                    </span>
                    {{ product.review }} đánh giá
                </div>
            </div>
        </div>
        <div class="row pt-3">
            <div class="col-6">
                <div id="carouselExample" class="carousel slide" data-bs-ride="carousel">
                    <div class="carousel-inner">
                        <div class="carousel-item active">
                            <img class="d-block" style="width: 100%; height: 400px;" :src="product.thumbnail" alt="First slide" />
                        </div>
                        <div v-for="(image, index) in product.images" :key="index" class="carousel-item">
                            <img class="d-block" style="width: 100%; height: 400px;" :src="image.url" alt="First slide" />
                        </div>
                    </div>
                    <a class="carousel-control-prev" href="#carouselExample" role="button" data-bs-slide="prev">
                        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                        <span class="visually-hidden">Previous</span>
                    </a>
                    <a class="carousel-control-next" href="#carouselExample" role="button" data-bs-slide="next">
                        <span class="carousel-control-next-icon" aria-hidden="true"></span>
                        <span class="visually-hidden">Next</span>
                    </a>
                </div>
                <div class="preview border d-flex justify-content-center pt-2">
                    <ul class="list-inline border" style="overflow-x: scroll;white-space: nowrap;">
                        <li class="list-inline-item m-1">
                            <a href="javascript:void(0)" data-bs-slide-to="0" data-bs-target="#carouselExample">
                                <img height="100" width="100" :src="product.thumbnail">
                            </a>
                        </li>
                        <li v-for="(image, index) in product.images" :key="index" class="list-inline-item m-1">
                            <a href="javascript:void(0)" :data-bs-slide-to="index+1" data-bs-target="#carouselExample">
                                <img height="100" width="100" :src="image.url">
                            </a>
                        </li>
                    </ul>
                </div>
            </div>
            <div class="col-6">
                <div class="d-flex justify-content-between">
                    <div v-if="product.quantity > 0" class="product-price d-flex">
                        <h3 class="price" v-if="product.sale > 0">{{ new Intl.NumberFormat().format((product.price * (100-product.sale) / 100 )) }}đ</h3>
                        <h4 class="p-2" :class="{'sale' : product.sale > 0}">{{ new Intl.NumberFormat().format(product.price) }}đ</h4>
                    </div>
                    <div class="outstock py-3" v-else>Hết hàng</div>
                    <span>Đã bán: {{ product.buycnt }}</span>
                </div>
                <div class="short p-3">
                    <h3 class="short-title">Thông số kỹ thuật</h3>
                    <span v-html="product.short"></span>
                </div>
                <div class="d-flex buy-now">
                    <button type="button" class="btn btn-danger d-none w-50 p-2 m-2">Mua ngay</button>
                    <button type="button" v-on:click="addToCart()" class="btn btn-primary w-50 p-2 m-2">Thêm vào giỏ hàng</button>
                </div>
            </div>
        </div>
        <hr/>
        <div class="row pt-3">
            <div class="col-md-9 col-12">
                <div class="description">
                    <h3>Mô tả sản phẩm</h3>
                    <hr>
                    <div v-html="product.description"></div>
                </div>
                <div class="description my-3">
                    <h3>Đánh giá sản phẩm</h3>
                    <hr>
                    <div class="row">
                        <div class="col-md-4 text-center d-grid">
                            <span class="fs-4">Đánh giá trung bình</span>
                            <span class="fs-3 review-product-point fw-bolder">{{ product.point }}/5</span>
                            <span>
                                <span v-for="(star, index) in roundedNum(product.point)" :key="index" class="fa-stack mx-1" style="width:1em;">
                                    <i v-if="star > product.point" class="fas fa-star-half fa-stack-1x"></i>
                                    <i v-else class="fas fa-star fa-stack-1x"></i>
                                </span>
                            </span>
                            <span>{{ product.review }} đánh giá</span>
                        </div>
                        <div class="col-md-5">
                            <div  v-for="(item, index) in star.slice().reverse()" :key="index" class="d-flex align-items-center justify-content-center">
                                <span>{{ 5-index }}</span>
                                <span class="fa-stack mx-1" style="width:1em;">
                                    <i class="fas fa-star fa-stack-1x"></i>
                                </span>
                                <div class="progress">
                                    <div class="progress-bar" role="progressbar" :style="'width:' + item[0] + '%'"></div>
                                </div>
                                <div class="count">{{ item[0] }}%</div>
                            </div>
                        </div>
                        <div class="col-md-3 d-flex align-items-center">
                            <div>
                                <span>Bạn đã dùng sản phẩm này?</span>
                                <button type="bottom" data-bs-toggle="modal" data-bs-target="#exampleModal" class="btn btn-primary d-flex mx-auto">Gửi đánh giá</button>
                            </div>
                        </div>
                    </div>
                    <hr/>
                    <div class="list-review">
                        <template v-for="(item,index) in reviews" :key="index">
                            <div class="d-flex pt-2">
                                <div class="flex-shrink-0 me-3">
                                    <div class="avatar">
                                        <img src="/assets/img/avatars/1.png" alt class="w-px-40 w-100 h-100 h-auto rounded-circle">
                                    </div>
                                </div>
                                <div class="flex-grow-1">
                                    <span class="fw-semibold d-block">
                                        {{ item.user ? item.user.name : item.name }} 
                                        <template v-if="item.type == 1">
                                            <span style="color: #2f855a; font-size: 12px;">
                                                <i class="fa-regular fa-circle-check"></i>
                                                Đánh giá sau khi mua hàng
                                            </span>
                                        </template>
                                    </span>
                                    <small class="text-muted">
                                        <span v-for="(star, index) in roundedNum(item.star)" :key="index" class="fa-stack mx-1" style="width:1em;">
                                            <i v-if="star > item.star" class="fas fa-star-half fa-stack-1x"></i>
                                            <i v-else class="fas fa-star fa-stack-1x"></i>
                                        </span>
                                    </small>
                                    <div class="">
                                        {{ item.comment }}
                                    </div>
                                    <div class="text-muted">
                                        {{ getTime(item.created_at) }} ngày trước
                                    </div>
                                </div>
                            </div>
                            <hr>
                        </template>
                    </div>
                </div>
            </div>
            <div class="col-md-3 col-12">
                <div class="description">
                    <h3>Sản phẩm khác</h3>
                    <div v-if="samilar.length > 0" class="product-list-index row">
                        <div v-for="(samilarItem,index) in samilar" :key="index" class="col-12 item pb-2">
                            <div class="card">
                                <div class="sale p-1">
                                    <img class="card-img-top" :src="samilarItem.thumbnail" :alt="samilarItem.name"/>
                                </div>
                                <div class="card-body pt-1">
                                    <span class="card-title fs-16 fw-500">{{ samilarItem.name }}</span>
                                    <div class="product-price-samilar d-flex pt-1 align-items-center">
                                        <span class="price" v-if="samilarItem.sale > 0">{{ new Intl.NumberFormat().format((samilarItem.price * (100-samilarItem.sale) / 100 )) }}đ</span>
                                        <span class="p-2" :class="{'sale' : samilarItem.sale > 0}">{{ new Intl.NumberFormat().format(samilarItem.price) }}đ</span>
                                    </div>
                                    <div class="pt-1 d-flex align-items-center justify-content-between">
                                        <div class="star">
                                            <span v-for="(star, index) in roundedNum(samilarItem.point)" :key="index" class="fa-stack m-1" style="width:1em;">
                                                <i v-if="star > samilarItem.point" class="fas fa-star-half fa-stack-1x"></i>
                                                <i v-else class="fas fa-star fa-stack-1x"></i>
                                            </span>
                                        </div>
                                        <span>Đã bán {{ samilarItem.buycnt }}</span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
<!-- Modal review -->
<div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="exampleModalLabel">Đánh giá sản phẩm</h3>
                <button ref="Close" type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <form autocomplete="off" @submit.prevent="postReview" method="post" class="needs-validation" novalidate>
                    <div class="modal-center-review">
                        <div class="image-product-review">
                            <img :src="product.thumbnail" :alt="product.name">
                        </div>
                        <div class="rate">
                            <input v-model="review.star" type="radio" id="star5" name="rate" :value=5 />
                            <label for="star5" title="text">5 stars</label>
                            <input v-model="review.star" type="radio" id="star4" name="rate" :value=4 />
                            <label for="star4" title="text">4 stars</label>
                            <input v-model="review.star" type="radio" id="star3" name="rate" :value=3 />
                            <label for="star3" title="text">3 stars</label>
                            <input v-model="review.star" type="radio" id="star2" name="rate" :value=2 />
                            <label for="star2" title="text">2 stars</label>
                            <input v-model="review.star" type="radio" id="star1" name="rate" :value=1 />
                            <label for="star1" title="text">1 star</label>
                        </div>
                    </div>
                    <div class="w-100">
                        <textarea 
                            required 
                            :class="{'is-invalid': errors?.comment}" 
                            v-model="review.comment" 
                            class="form-control" rows="3" 
                            placeholder="Hãy chia sẻ cám nhận của bạn về sản phẩm...">
                        </textarea>
                        <div v-if="errors?.comment" class="invalid-feedback">{{ errors?.comment[0] }}</div>
                    </div>
                    <div class="info-review pt-3">
                        <div class="d-flex">
                            <div class="w-100">
                                <input 
                                :class="{'is-invalid': errors?.name}"
                                v-model="review.name" required
                                type="text" class="form-control me-1" 
                                placeholder="Nhập họ và tên">
                                <div v-if="errors?.name" class="invalid-feedback">{{ errors?.name[0] }}</div>
                            </div>
                            <div class="w-100">
                                <input 
                                    :class="{'is-invalid': errors?.phone}"
                                    v-model="review.phone" required
                                    type="text" class="form-control ms-1" 
                                    placeholder="Nhập số điện thoại">
                                <div v-if="errors?.phone" class="invalid-feedback">{{ errors?.phone[0] }}</div>
                            </div>
                        </div>
                        <div class="w-100">
                            <input 
                                :class="{'is-invalid': errors?.email}"
                                v-model="review.email" required
                                type="email" class="form-control mt-2" 
                                placeholder="Nhập email để nhận thông báo phản hồi">
                            <div v-if="errors?.email" class="invalid-feedback">{{ errors?.email[0] }}</div>
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer d-flex justify-content-center">
                <button v-on:click="postReview()" type="button" class="btn btn-primary">Gửi đánh giá</button>
            </div>
        </div>
    </div>
</div>

<!-- Modal review success -->
<button type="bottom" ref="openSuccesReview" data-bs-toggle="modal" data-bs-target="#staticBackdrop" class="btn btn-primary d-none">Review success</button>

<div class="modal fade" id="staticBackdrop" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-body">
                <h3 class="text-center">
                    Gửi đánh giá thành công
                </h3>
                <span class="text-center fs-5">
                    Cảm ơn quỳ khách đã chia sẻ ý kiến về sản phẩm.
                </span>
                <span class="text-center fs-5">
                    Đánh giá sẽ được kiểm duyệt và cập nhật sớm nhất.
                </span>
            </div>
            <div class="modal-footer d-flex justify-content-center">
                <button type="button" class="btn btn-primary" data-bs-dismiss="modal">Xác nhận</button>
            </div>
        </div>
    </div>
</div>
<div class="position-fixed top-0 end-0 p-3" style="z-index: 11111">
  <div data-delay="41000" ref="el" id="liveToast" class="toast hide" :class="{'bg-info': errorToast, 'bg-danger': !errorToast}" role="alert" aria-live="assertive" aria-atomic="true">
    <div class="toast-header pb-2">
      <strong class="me-auto">Thông báo mới</strong>
      <small>Bây giờ</small>
      <button type="button" class="btn-close" data-bs-dismiss="toast" aria-label="Close"></button>
    </div>
    <div class="toast-body pt-2">
        {{ message }}
    </div>
  </div>
</div>
</template>

<script>
const { Toast } = bootstrap
    export default {
        name: 'detail-product',
        data(){
            return {
                review: {
                    product_id: this.product.id,
                    type: 0,
                    status: 0,
                    name: '',
                    email: '',
                    phone: '',
                    comment: '',
                    star: 5
                },
                errors: {},
                reviews: Array,
                message: '',
                errorToast: false
            }
        }, 
        props:{
            product:{
                type: Object,
                required: true
            },
            samilar : {
                type: Array,
                required: true
            },
            star: {
                type: Object,
                required: true
            }
        },
        methods: {
            roundedNum(num) {
                return Math.round(num);
            },
            setStar(star){
                this.review.star = star;
            },
            postReview(){
                this.$store.dispatch('review', this.review).then(res => {
                    if(res.status === 200) {
                        this.$refs.Close.click();
                        this.$refs.openSuccesReview.click();
                    }
                }).catch(error => {
                    this.errors = error.response.data.errors;
                })
            },
            getReview(){
                this.$store.dispatch('getReview', this.product.id).then(res => {
                    this.reviews = res.data.data;
                })
            },
            getTime(time){
                const specificDate = new Date(time);

                // Get today's date
                const today = new Date();

                // Calculate the time difference in milliseconds
                const timeDifference = today.getTime() - specificDate.getTime();

                // Convert milliseconds to days
                const daysDifference = Math.floor(timeDifference / (1000 * 60 * 60 * 24));

                return daysDifference;
            },
            showToast(){
                var toast = new Toast(this.$refs.el)
                toast.show();
            },
            addToCart(){
                this.errorToast = true;
                if(this.product.quantity === 0) {
                    this.message = 'Sản phẩm đã hết hàng';
                    this.errorToast = false;
                    this.showToast();
                    return;
                }
                let data = {
                    product_id: this.product.id,
                    quantity: 1
                }
                this.$store.dispatch('addToCart', data).then(res => {
                    if(res.status === 200) {
                        this.message = 'Thêm sản phẩm thành công!!!'
                        this.showToast();
                    }
                })
            }
        },
        mounted(){
            this.getReview();
            console.log(this.star);
        }
    }
</script>
<style lang="scss">
.product-detail {
    .image-product-review img{
    width: 100px;
    height: 100px;
}
.modal-center-review {
    display: flex;
    flex-direction: column;
    align-items: center;
}
.sale{
    font-weight: 400;
    color: #99a2aa;
    text-decoration: line-through;
    font-size: 20px;
}
.count {
    width: 45px;
    text-align: center;
}
.price {
    font-weight: 700;
    color: #cb1c22;
    font-size: 32px;
}
.product-price-samilar .price {
    font-weight: 700;
    color: #cb1c22;
    font-size: 20px;
}
.review-product-point {
    color: #cb1c22;
}
.product-price-samilar .sale{
    font-weight: 400;
    color: #99a2aa;
    text-decoration: line-through;
    font-size: 14px;
}
.product-price {
    align-items: end;
}
.short-title {
    justify-content: space-between;
    color: #212529;
}
h3{
    color: #212529;
}
.short {
    border-radius: 4px;
    border: solid 1px #e9ecef;
    background-color: #f8f9fa;
}
.outstock {
    font-size: 32px;
    color: #cb1c22;
    font-weight: 700;
}
.description {
    color: #212529;
    padding: 15px ;
    border-radius: 5px;
    border: solid 1px #e9ecef;
    background-color: #f8f9fa;
}
.buy-now button{
    font-size: 20px;
}
.card-body {
    height: auto !important;
    padding: 0.5rem 0.5rem !important;
}
.progress {
    width: 90%;
}
.rate {
    float: left;
    height: 46px;
    padding: 0 10px;
}
.rate:not(:checked) > input {
    position:absolute;
    top:-9999px;
}
.rate:not(:checked) > label {
    float:right;
    width:1em;
    overflow:hidden;
    white-space:nowrap;
    cursor:pointer;
    font-size:30px;
    color:#ccc;
}
.rate:not(:checked) > label:before {
    content: '★ ';
}
.rate > input:checked ~ label {
    color: #cb1c22;    
}
.rate:not(:checked) > label:hover,
.rate:not(:checked) > label:hover ~ label {
    color: #cb1c22;  
}
.rate > input:checked + label:hover,
.rate > input:checked + label:hover ~ label,
.rate > input:checked ~ label:hover,
.rate > input:checked ~ label:hover ~ label,
.rate > label:hover ~ input:checked ~ label {
    color: #cb1c22;
}
}

.sale{
    font-weight: 400;
    color: #99a2aa;
    text-decoration: line-through;
    font-size: 20px;
}
.price {
    font-weight: 700;
    color: #cb1c22;
    font-size: 32px;
}
.product-price-samilar .price {
    font-weight: 700;
    color: #cb1c22;
    font-size: 20px;
}
.review-product-point {
    color: #cb1c22;
}

</style>